// http://www.phidels.com

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Tlhelp32;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

// cette fonction sera appele pour chaque lorsque l'on appelera l'API EnumWindows
function EnumWindowsCallback(hWnd: HWND; lParam: LPARAM): BOOL; stdcall;

implementation

{$R *.DFM}
Function GetProcessNameFromHandle(Handle:HWND):string;
//fonction faite par ZeuS-[SFX] (voir les units phidels.pas)
// donne,  partir du handle d'une fentre, l'excutable  l'origine de cette fentre
var
  Pid:DWord;
  SnapShot:HWND;
  Module:TModuleEntry32;
begin
  Result:='';
  if not IsWindow(Handle) then exit;
  GetWindowThreadProcessId(Handle,@Pid); // rcupere le pid
  Snapshot:=CreateToolhelp32Snapshot(TH32CS_SNAPMODULE,Pid); // creer un snapshot sur le pid
  try
    if Snapshot<>-1 then
    begin
      Module.dwSize:=SizeOf(TModuleEntry32);
      if Module32First(Snapshot,Module) then  result:=Module.szExePath; // recupere l'exe path
    end;
  finally
    CloseHandle(Snapshot);
  end;
end;

// cette fonction sera appele pour chaque lorsque l'on appelera l'API EnumWindows
function EnumWindowsCallback(hWnd: HWND; lParam: LPARAM): BOOL;
Var Texte:array[0..250]of Char;
    Classe:array[0..250]of Char;
begin
  GetWindowText(hWnd,Texte,SizeOf(Texte)); // rcupration du texte de la fentre
  GetClassName(hWnd,Classe,SizeOf(Classe)); // rcupration de la classe
  Form1.Memo1.lines.add('classe :'+Classe+'      Texte: '+Texte+'    Handle: '+IntToStr(hWnd)
  +' Excutable : '+GetProcessNameFromHandle(hWnd));
  result:=true;// pour que l'numration ne s'arrte pas; pour que EnumWindows continue  appeler EnumWindowsCallback pour les autres fentres
end;



procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo1.Clear;
  EnumWindows(@EnumWindowsCallback,0);// EnumWindows va appeler EnumWindowsCallback pour chaque fenetre prsente
end;

end.
